/*------------------------------------------------------------------------------
						ANAGLYPH
------------------------------------------------------------------------------*/

float4 AnaglyphPass( float4 colorInput, float2 Tex )
{
	float4 Anaglyph = colorInput;
	float Seperation = 1;
	float RedPower = 0;
	float GreenPower = 0;
	float BluePower = 0;
	// Validating user settings
	if (AnaglyphSeperation < 1 || AnaglyphSeperation > 9) Seperation = 1;
	else Seperation = (AnaglyphSeperation * 0.0000001) + 0.0004;
	if (AnaglyphRed < 1 || AnaglyphRed > 1) RedPower = 0.001;
	else RedPower = AnaglyphRed * 0.081;
	if (AnaglyphGreen < 1 || AnaglyphGreen > 1) GreenPower = 0.001;
	else GreenPower = AnaglyphGreen * 0.041;
	if (AnaglyphBlue < 1 || AnaglyphBlue > 1) BluePower = 0.001;
	else BluePower = AnaglyphBlue * 0.082;
	// Setting RGB channel colors
	float red = dot(Anaglyph.rgb, float4(2.55, 0, 0, 0));
	float green = dot(Anaglyph.rgb, float4(0,2.55,0,0));
	float blue = dot(Anaglyph.rgb, float4(0,0,2.55,0));
	// Setting the RGB channel powers
	float4 red2 = red * RedPower;
	float4 green2 = green * GreenPower;
	float4 blue2 = blue * BluePower;
	// Left Eye (Red)
	float4 LeftEye = tex2D(s0, float2(Tex + float2(-Seperation,0))).rgba;
	red2 = max(red2, LeftEye);
	// Right Eye (Cyan)
	float4 RightEye = tex2D(s0, float2(Tex + float2(Seperation,0))).rgba;
	green2 = max(blue2,RightEye);
	blue2 = max(blue2,RightEye);
	float4 cyan = (green2 + blue2) / 2;
	// Combine
	Anaglyph.r = red2.r;
	Anaglyph.g = blue2.g;
	Anaglyph.b = blue2.b;
	Anaglyph.a = red2.b;
	return Anaglyph;
}