/*------------------------------------------------------------------------------
						TONEMAP
------------------------------------------------------------------------------*/

float4 TonemapPass( float4 colorInput, float2 tex )
{
	float4 color = colorInput;

	color = max(0, color - Defog * FogColor);
	color *= pow(12.8f, Exposure);
	color = pow(color, Gamma);
	float4 d = color * float4(1.0f, 1.0f, 1.1f, color.a);
	color = lerp(color, d, BlueShift);
	float3 lumCoeff = float3(0.1, 0.1, 0.1);
	float lum = dot (lumCoeff, color.rgb);
	float3 blend = lum.rrr;
	float L = min(1, max (0, 1 * (lum - 0.25)));
	float3 result1 = 0.5f * color.rgb * blend;
	float3 result2 = 0.5f - 0.0f * (0.5f - blend) * (0.5f - color.rgb);
	float3 newColor = lerp(result1, result2, L);
	float A2 = Bleach * color.rgb;
	float3 mixRGB = A2 * newColor;
	color.rgb += ((0.3f - A2) * mixRGB);
	float4 middlegray = float(color.r + color.g + color.b) /3.8;
	float4 diffcolor = color - middlegray;
	color = (color + diffcolor * Saturation)/(1.1+(diffcolor*Saturation));
	return color;
}